
# WeblogsActionMenu.pl
# WeblogsActionMenu plugin for Movable Type
# by Kevin Shay
# http://www.staggernation.com/mtplugins/WeblogsActionMenu/

use strict;
package MT::Plugin::WeblogsActionMenu;

use vars qw( $VERSION );
$VERSION = '1.1';

require MT::Plugin;
require MT;
my $plugin = MT::Plugin->new({
	name => "WeblogsActionMenu",
	description => 'Jump directly to a specific action for a different weblog.',
	doc_link => 'http://www.staggernation.com/mtplugins/WeblogsActionMenu/',
	author_name => 'Kevin Shay',
	author_link => 'http://www.staggernation.com/',
	version => $VERSION
});
MT->add_plugin($plugin);

#MT->add_callback('bigpapi::template', 9, $plugin, \&_template);
MT->add_callback('MT::App::CMS::AppTemplateSource', 9, $plugin, \&_template);

sub _template {
	my ($cb, $app, $template) = @_;
	my $old = qq{<MT_TRANS phrase="Go to:">};
	$old = quotemeta($old);
	my $new = <<HTML;
<MT_TRANS phrase="Go to:">
<script type="text/javascript">
var wam_type;
var wam_subtype;
var wam_mode = 'menu';
function blog_menu_change(loc) {
	loc = loc.replace(/=menu/, '=' + wam_mode);
	if (wam_type) {
		loc += '&_type=' + wam_type;
	}
	if (wam_subtype) {
		loc += '&type=' + wam_subtype;
	}
	window.location.href = loc;
}
function action_menu_change(menu) {
	wam_mode = menu.options[menu.selectedIndex].value;
	if (wam_mode == 'list') {
		if (menu.selectedIndex == 6) {
			wam_type = 'notification';
		} else {
			wam_type = 'template';
		}
	} else if (wam_mode == 'view') {
		if ((menu.selectedIndex >= 8) && (menu.selectedIndex <= 10)) {
			wam_type = 'template';
			if (menu.selectedIndex == 8) {
				wam_subtype = 'index';
			} else if (menu.selectedIndex == 9) {
				wam_subtype = 'archive';
			} else {
				wam_subtype = 'module';
			}
		} else {
			wam_type = 'entry';
		}
	} else {
		wam_type = '';
		wam_subtype = '';
	}
}
</script>
<select name="mode" onchange="action_menu_change(this);">
<option value="menu" selected="selected"><MT_TRANS phrase="Menu"></option>
<option value="view"><MT_TRANS phrase="New Entry"></option>
<option value="list_entries"><MT_TRANS phrase="Entries"></option>
<option value="list_comments"><MT_TRANS phrase="Comments"></option>
<option value="list_commenters"><MT_TRANS phrase="Commenters"></option>
<option value="list_pings"><MT_TRANS phrase="TrackBacks"></option>
<option value="list"><MT_TRANS phrase="Notifications"></option>
<option value="list"><MT_TRANS phrase="Templates"></option>
<option value="view"><MT_TRANS phrase="New Index Template"></option>
<option value="view"><MT_TRANS phrase="New Archive Template"></option>
<option value="view"><MT_TRANS phrase="New Template Module"></option>
<option value="list_cat"><MT_TRANS phrase="Categories"></option>
<option value="list_tags"><MT_TRANS phrase="Tags"></option>
<option value="cfg_prefs"><MT_TRANS phrase="Settings: General"></option>
<option value="cfg_entries"><MT_TRANS phrase="Settings: Defaults"></option>
<option value="cfg_feedback"><MT_TRANS phrase="Settings: Feedback"></option>
<option value="cfg_archives"><MT_TRANS phrase="Settings: Publishing"></option>
<option value="cfg_plugins"><MT_TRANS phrase="Settings: Plugins"></option>
<option value="search_replace"><MT_TRANS phrase="Search &amp; Replace"></option>
<option value="view_log"><MT_TRANS phrase="Activity Log"></option>
<option value="start_import"><MT_TRANS phrase="Import/Export"></option>
</select> <MT_TRANS phrase="in blog"> 
HTML
	$$template =~ s/$old/$new/;
	$old = 'window.location.href=this.value;';
	$old = quotemeta($old);
	$new = 'blog_menu_change(this.value);';
	$$template =~ s/$old/$new/;
}

1;
